
Installer - Feature #36854

Use HTTP/2 on content proxies to connect to Foreman

10/23/2023 01:01 PM - Ewoud Kohl van Wijngaarden

Status: Closed   

Priority: Normal   

Assignee: Ewoud Kohl van Wijngaarden   

Category: Foreman modules   

Target version:    

Difficulty:  Fixed in Releases: 3.9.0

Triaged: No Found in Releases:  

Bugzilla link: 2152709 Red Hat JIRA:  

Pull request: https://github.com/theforeman/puppet-for

eman_proxy_content/pull/442

  

Description

The HTTP/1.1 protocol can cause TCP race conditions when using keepalive. 

https://iximiuz.com/en/posts/reverse-proxy-http-keep-alive-and-502s/ does a good job of describing this. HTTP/2 doesn't use

keepalive but instead has multiplexing of multiple streams together with a control channel. Testing shows this to be much more

reliable, especially at higher concurrency.

Associated revisions

Revision e7a38f3d - 10/24/2023 12:32 PM - Ewoud Kohl van Wijngaarden

Fixes #36854 - Use HTTP/2 when proxying to Foreman

This aims to use mod_proxy_http2, which utilizes HTTP/2 to a backend

server. It depends on a feature released in puppetlabs-apache 10.1.1.

Overall testing shows the connection is much more stable and reliable

than with HTTP/1.1, especially in higher concurrency. It is recommended

to keep this on, but there is an option to disable it if for some reason

it doesn't work. In the future this same option can be used to support

HTTP/3 when Apache implements that.

History

#1 - 10/23/2023 01:01 PM - The Foreman Bot

- Status changed from New to Ready For Testing

- Assignee set to Ewoud Kohl van Wijngaarden

- Pull request https://github.com/theforeman/puppet-foreman_proxy_content/pull/442 added

#2 - 10/23/2023 01:07 PM - Ewoud Kohl van Wijngaarden

- Bugzilla link set to 2152709

#3 - 10/24/2023 12:32 PM - The Foreman Bot

- Fixed in Releases 3.9.0 added

#4 - 10/24/2023 01:00 PM - Ewoud Kohl van Wijngaarden

- Status changed from Ready For Testing to Closed

Applied in changeset puppet-foreman_proxy_content|e7a38f3d5a3c08dcaa8aa36d7b206e8c49204a67.
